/*$Header: ansifuncs.c,v 4.0 94/02/01 20:18:04 tedd Exp $*/

/******************************************************************
        Module Name: ansic.functions.c

        Auxiliary functions of error recovery for
        Standard ANSI C Parser

        Programmer: Xiaokang Yu
        Date: Aug 2, 1992
******************************************************************/

#include <stdio.h>

FILE *yyerfp = stderr;
extern int yylineno;
extern char yytext[];
extern int yyleng;

static char *source;

yywhere()
{
  char colon = 0;
  
  if (source && *source && strcmp(source, "\"\"")) 
  {
    char *cp = source;
    int len = strlen(source);
    
    if (*cp == '"')
      ++cp, len -= 2;
    if (strncmp(cp, "./", 2) == 0)
      cp += 2, len -= 2;
    fprintf(yyerfp, "file %.*s", len, cp);
    colon = 1;
  }
  
  if (yylineno > 0) 
  {
    if (colon)
      fputs(", ", yyerfp);
    fprintf(yyerfp, "\nline %d",
            yylineno - (*yytext == '\n' || ! *yytext));
    colon = 1;
  }

  if (*yytext) 
  {
    register int i;
    for (i = 0; i < 20; ++i)
      if (!yytext[i] || yytext[i] == '\n')
        break;
    if (i) 
    {
      if (colon)
        putc (' ', yyerfp);
      fprintf(yyerfp, "near \"%.*s\"", 1, yytext);
      colon = 1;
    }
  }

  if (colon)
    fputs (": ", yyerfp);
}

yymark()
{
  if (source)
    cfree(source);
  source = (char *) calloc(yyleng, sizeof(char));
  if (source)
    sscanf(yytext, "# %d %s", &yylineno, source);
}

yyerror(s)
     register char *s;
{
  extern int yynerrs;
  
  fprintf(yyerfp, "\n[error %d] ", yynerrs + 1);
  yywhere();
  fputs(s, yyerfp);
  putc('\n', yyerfp);
}

yywrap()
{
  return(1);
}




