/* $Header: common.c,v 4.0 94/02/01 20:20:26 tedd Exp $ */

#include "sp-code.h"
#include "common.h"

/*    malloc_module

      called by :

      This procedure makes, initializes, and returns a new module_info
      structure.
*/

struct module_info *malloc_module( )
{
	struct module_info *temp;
	int counter;
	temp = (struct module_info *) malloc( sizeof( struct module_info ) );

	temp->module_name = NULL;
	temp->is_prototype = 0;
	temp->code_block = NULL;
	temp->identifiers = NULL;
	temp->num_of_parameters = 0;
	temp->lines_of_code = 0;
        temp->union_lines = 0;

        /* DEA - 93: Added num_of_header_lines to get accurate count of LOC or NCSS */
        temp->num_of_header_lines = 0;

	temp->num_of_comment_lines = 0;
	temp->num_of_uncrowded_statements = 0;
	temp->num_of_statements = 0;
	temp->max_nesting = 0;
	
	for( counter = 0; counter < OPERATOR_SIZE ; counter++ )
		temp->operators[counter] = 0;
	temp->operands = NULL;
	temp->operands_unique = 0;
	temp->operands_total = 0;

/*lowther93: This isn't a real good name for v(g).. */
	temp->num_of_keywords = 0;   /*    V(G)   */

	temp->fan_in = 0;
	temp->fan_out = 0;
	temp->recursive_calls = 0;
	temp->num_of_io_calls = 0;
	temp->num_of_external_files = 0;

	temp->num_of_identifiers = 0;
	temp->num_of_globals_used = 0;
	temp->num_of_unused_identifiers = 0;
	temp->num_of_well_declared_identifiers = 0;
	temp->num_of_initalized_identifiers = 0;
	temp->num_of_meaningful_identifiers= 0;
	temp->average_span = 0.0;
	temp->max_span = 0;

	temp->is_indented = 0;
	temp->contains_comment_headers = 0;
	temp->has_horizontal_spacing = 0;
	temp->has_vertical_spacing = 0;
	return( temp );
	}


/*    free_module

      called by :

      This procedure frees up the space created for a module struct.
*/

void free_module( struct module_info *temp )
{
  free( temp );
}
	


/*     malloc_id

       called by :

       This procedure makes, initializes, and returns a new id_info
       structure.
*/

struct id_info *malloc_id()
{
  struct id_info *temp;
  temp = (struct id_info *)malloc( sizeof( struct id_info ) );

  temp->id_name = NULL;

  temp->first_line_seen = 0;
  temp->last_line_seen = 0;

  temp->num_of_times_seen = 0;

  temp->initialized = 0;
  return( temp );
}


/*     free_id

       called by :

       This procedure frees up the space created for a id_info struct.
*/

void free_id( struct id_info *temp )
{
  free( temp->id_name );
  free( temp );
}


/*     malloc_link

       called by :

       This procedure makes, initializes, and returns a new link_list
       struct.
*/

struct link_list *malloc_link()
{
  struct link_list *temp;
  temp = (struct link_list *)malloc( sizeof( struct link_list ) );
  
  temp->information = malloc_id();
  temp->next_node = NULL;
  return( temp );
}


/*     free_link

       called by :

       This procedure frees up the space created for a link_list struct.
*/

void free_link( struct link_list *temp )
{
  free_id( temp->information );
  free( temp );
}


/*     malloc_tree

       called by :
       calls : malloc_id.

       This procedure makes, initializes, and returns a new tree struct.
*/

struct tree *malloc_tree()
{
  struct tree *temp;
  temp = (struct tree *)malloc( sizeof( struct tree ) );

  temp->information = malloc_id();
  temp->left_node = NULL;
  temp->right_node = NULL;
  return( temp );
}


/*     free_tree

       called by :
       calls : free_id.

       This procedure frees up the space created for a tree struct.
*/

void free_tree( struct tree *temp )
{
  free_id( temp->information );
  free( temp );
}


/*     copy_string

       called by :

       This procedure makes a new copy of the string and returns it.
*/

char *copy_string( char *string )
{
  char *string2;
  int length;
  length = strlen( string );
  string2 = (char *)malloc( sizeof( char ) * (length+1) );
  return strcpy( string2, string );
}


/*     yyid_copy

       called by :

       This procedure makes a copy of the string in yyidentifier and
       returns it.
*/

char *yyid_copy()
{
  char *string;
  int length;
  length = strlen( yyidentifier );
  string = (char *)malloc( sizeof( char ) * (length+1) );
  return strcpy( string, yyidentifier );
}
