/*$Header: getdata.c,v 4.0 94/02/01 20:21:18 tedd Exp $*/

/**************************************************************************
 *
 *	getdata file for the MAS-CII Maintainability Tool
 *	CS 481 Senior Group Project - Fall 1992
 *	Group Members: Craig Anderson, Kelly Hall, Vince Lowe 
 *		       Theresa Rhoades, Dayne Steed
 *	Date File Created:  October 20, 1992
 *	Last File Updated:  December 7, 1992
 *
 ****************************************************************************/


/*
  getdata.c reads in the data.dump file from stdin and calculates the
  remaining module and overall metrics.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <string.h>

#include "globals.h"

int  modcount;

/*
  This procedure will read in the data dump file and fill the global
  data structure called all_metrics, and the local array of structures
  called mod_table.
*/


void GetData()
{
  FILE   *fp = stdin;  
  char   specifier = 'M';
  char   specifier_temp = 'M';
  char dumstring[32];
  int    tot_opors,
  tot_opnds,
  uni_opors,
  uni_opnds,
  dumint,
  tot_stmnts,
  tot_initvars,
  Num_of_Vars;
  /*lowther93: num of vars added for % init vars calculation */
  
  float  ftemp,
  ftemp_numerator,
  ftemp_denomonator;
  
  modcount=0;
  
  do
  {
    fscanf(fp, "%c", &specifier);
    specifier_temp = specifier;
    if (specifier == 'M') 
    {
      fscanf(fp, "%s", &(mod_table[modcount]->name[0]));
      fscanf(fp, "%d", &mod_table[modcount]->num_params);
      fscanf(fp, "%d", &mod_table[modcount]->LOC);    
      /*  TED '94--Added retrieval of Non Commented Source Statement
       *           LOC.
       */
      fscanf(fp, "%d", &mod_table[modcount]->NCSS);
      fscanf(fp, "%d", &mod_table[modcount]->num_stmnts);
      
      fscanf(fp, "%d", &mod_table[modcount]->num_uncrowd_stmnt);
      
      fscanf(fp, "%d", &mod_table[modcount]->num_comments);
      fscanf(fp, "%d", &mod_table[modcount]->max_nest);
      
      fscanf(fp, "%d", &uni_opors);           /* unique operators*/
      fscanf(fp, "%d", &tot_opors);           /* total operators*/
      fscanf(fp, "%d", &uni_opnds);           /* unique operands*/
      fscanf(fp, "%d", &tot_opnds);           /* total operands*/
      fscanf(fp, "%d", &mod_table[modcount]->vsubg);
      fscanf(fp, "%d", &mod_table[modcount]->fanin);
      fscanf(fp, "%d", &mod_table[modcount]->fanout);
      fscanf(fp, "%d", &mod_table[modcount]->num_rec_calls);
      
      fscanf(fp, "%d", &mod_table[modcount]->num_iocall);
      fscanf(fp, "%d", &mod_table[modcount]->ext_files); 
      
      fscanf(fp, "%d", &mod_table[modcount]->header);
      fscanf(fp, "%d", &mod_table[modcount]->horiz_sp);
      fscanf(fp, "%d", &mod_table[modcount]->vert_sp);
      fscanf(fp, "%d", &mod_table[modcount]->indent);
      
      fscanf(fp, "%d", &mod_table[modcount]->num_local);
      fscanf(fp, "%d", &mod_table[modcount]->global); 
      fscanf(fp, "%d", &mod_table[modcount]->unusedvar);
      fscanf(fp, "%d", &mod_table[modcount]->num_welldecl);
      fscanf(fp, "%d", &mod_table[modcount]->num_initvars);
      fscanf(fp, "%d", &mod_table[modcount]->num_mean_vars);
      
      fscanf(fp, "%f", &mod_table[modcount]->ave_span);
      fscanf(fp, "%d", &mod_table[modcount]->max_span);
      fscanf(fp, "%c", &specifier);
      fscanf(fp, "%c", &specifier);
      
      /* lowther93: num of vars is used to hold global + local */
      Num_of_Vars = mod_table[modcount]->num_local
        + mod_table[modcount]->global;
      
      /* compute % well declared vars using locals as total # of vars*/
      if (Num_of_Vars == 0)
        mod_table[modcount]->percent_initvars = 0.0;
      else
        /* compute % initialized vars*/
        mod_table[modcount]->percent_initvars =	(float)
          ((float)(mod_table[modcount]->num_initvars)
           /(float) Num_of_Vars) * 100;
      
      /*lowther93: check for div by zero with num_local */

      if(mod_table[modcount]->num_local == 0)
      {	
        mod_table[modcount]->percent_welldecl = 0.0;
        mod_table[modcount]->percent_meaningful = 0.0;
      }
      else
      {
        mod_table[modcount]->percent_welldecl = (float)
          (((float)mod_table[modcount]->num_welldecl
            / (float)mod_table[modcount]->num_local)
           * 100); 
        
        mod_table[modcount]->percent_meaningful = (float)
          ((float)(mod_table[modcount]->num_mean_vars 
                   / (float) mod_table[modcount]->num_local)
           * 100);
      }
      
      /* compute % uncrowded statements*/
      
      if (mod_table[modcount]->num_stmnts == 0)
        mod_table[modcount]->percent_uncrowd_stmnts = 0.0;
      else
        mod_table[modcount]->percent_uncrowd_stmnts = 
          (float)((mod_table[modcount]->num_uncrowd_stmnt
                   / (float)mod_table[modcount]->num_stmnts)
                  * 100);
      
      /*compute % comments in a module*/
      
      if (mod_table[modcount]->LOC + mod_table[modcount]->num_comments == 0)
        mod_table[modcount]->percent_comments = 0.0;
      else
        
         mod_table[modcount]->percent_comments = (float)((float)
                 (mod_table[modcount]->num_comments / ((float)
                  mod_table[modcount]->LOC )) * 100);
         
       
     /*  TED '94--No longer using this             
      *  mod_table[modcount]->percent_comments = (float)((float)
      *           (mod_table[modcount]->num_comments / ((float)
      *            mod_table[modcount]->LOC  +
      *            mod_table[modcount]->num_comments) * 100));
      */

      /* compute Halstead's volume */
      mod_table[modcount]->Halv=((float)
                                 (tot_opors+tot_opnds))*
                                 ((float)log10((double)(uni_opors+uni_opnds)))
                                 /((float)log10((double)2.0));
      
      
      /* compute Halstead's effort */
      if ((uni_opors == 0) || (tot_opnds == 0))
        mod_table[modcount] -> Hale = 0.00;
      else
      {
/*      ftemp_numerator=(float)(2.0/(float)uni_opors);
        ftemp_denomonator=
          (float)((uni_opnds/(float)tot_opnds));
        ftemp = ftemp_numerator/ftemp_denomonator;
*/        
        mod_table[modcount]->Hale = 
          mod_table[modcount]->Halv*(uni_opors*tot_opnds) / (2.0*uni_opnds);
      }
      modcount++;
      
    }  /*  end if specifer_temp == 'M' */
    
  } 
  
  while(specifier_temp == 'M');	/*  end while specifier_temp == 'M' */
  
  all_metrics.tot_mods = modcount;
  num_mods = modcount;
  mod_tab_size = modcount;
  
  fscanf(fp, "%c", &specifier);
  fscanf(fp, "%s",  dumstring);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &all_metrics.tot_LOC);   /* total lines of code*/
  /*  TED '94--Added retrieval of Non Commented Source Statements global
   *           LOC.
   */
  fscanf(fp, "%d", &all_metrics.tot_NCSS);

  /*all_metrics.tot_LOC = 180;*/

  fscanf(fp, "%d", &tot_stmnts);
  fscanf(fp, "%d", &all_metrics.tot_uncrowd_stmnt);
  fscanf(fp, "%d", &all_metrics.tot_comments);
  fscanf(fp, "%d", &dumint);
  
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &all_metrics.tot_ext_files);    
  
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &dumint);
  
  fscanf(fp, "%d", &all_metrics.tot_global);       
  
  fscanf(fp, "%d", &dumint);
  fscanf(fp, "%d", &all_metrics.tot_unusedvar);
  fscanf(fp, "%d", &all_metrics.tot_welldecl);      
  
  fscanf(fp, "%d", &tot_initvars);                      
  
  fscanf(fp, "%d", &all_metrics.tot_mean_vars); 
  
  fscanf(fp, "%f", &all_metrics.ave_var_span);
  fscanf(fp, "%d", &all_metrics.max_var_span);
  fscanf(fp, "%d", &all_metrics.num_prep);
}

void CalcGlobal() 
{
  int   i,
  tot_fanin,
  tot_iocalls,
  tot_max_nest,
  tot_init_vars,
  num_params,
  maxcount,
  sum_comments;
  float sum_percents,
  sum_per_mean;
  
  /* initialize totals */

/* TED '94--Removed following line to get a correct count global lines of code.
 *	    Global lines of code are stored in all_metrics.tot_LOC initially.
  all_metrics.tot_LOC = 0;
 */
  all_metrics.tot_vsubg = 0;
  all_metrics.tot_Halv = 0;
  all_metrics.tot_Hale = 0;
  all_metrics.tot_rec_mod = 0;
  all_metrics.tot_local = 0;
  all_metrics.tot_unusedvar = 0;
  all_metrics.tot_welldecl = 0;
  all_metrics.mods_with_except = 0;
  all_metrics.max_LOC = 0;
  /*  TED '94--Added initialization of max_NCSS
   */
  all_metrics.max_NCSS = 0;
  all_metrics.max_vsubg = 0;
  all_metrics.max_nesting = 0;
  all_metrics.max_var_mod = 0;
  all_metrics.mod_with_indent = 0;
  all_metrics.mod_with_comments = 0;
  all_metrics.mod_with_header = 0;
  all_metrics.mod_with_vert_sp = 0;
  all_metrics.mod_with_horiz_sp = 0;
  all_metrics.max_fanin = 0;
  all_metrics.max_nesting = 0;
  tot_iocalls = 0;
  tot_init_vars = 0;
  num_params = 0;
  tot_fanin = 0;
  tot_max_nest = 0;
  sum_percents = 0.00;
  sum_per_mean = 0.00;
  sum_comments = 0;
  /* sm added initialization of ave.var.span & max.var.span sm */
  all_metrics.ave_var_span = 0.00;
  all_metrics.max_var_span = 0.00;
  
  /* add up totals of mod_table */

  for(i =0 ; i < num_mods; i++)
  {
    all_metrics.tot_LOC += mod_table[i]->LOC;
    /*  TED '94--Added tot_NCSS calculation.
     */
    all_metrics.tot_NCSS += mod_table[i]->NCSS;
    all_metrics.tot_vsubg += mod_table[i]->vsubg;
    all_metrics.tot_Halv += mod_table[i]->Halv;
    all_metrics.tot_Hale += mod_table[i]->Hale;
    
    if (mod_table[i]->num_rec_calls > 0)
      all_metrics.tot_rec_mod++;
    
    all_metrics.tot_local += mod_table[i]->num_local;
    all_metrics.tot_unusedvar += mod_table[i]->unusedvar;
    all_metrics.tot_welldecl += mod_table[i]->num_welldecl;
    sum_comments += mod_table[i]->num_comments;
    sum_percents += mod_table[i]->percent_comments;
    sum_per_mean += mod_table[i]->percent_meaningful;
    /* sm moved from met_dump.c */
    all_metrics.ave_var_span += mod_table[i]->ave_span;
    
    if (mod_table[i]->num_except > 0)
      all_metrics.mods_with_except++;
    
    if (all_metrics.max_LOC < mod_table[i]->LOC)
      all_metrics.max_LOC = mod_table[i]->LOC;

      /* sm moved calculation of ave_var_span & max_var_span from
      all_metrics to here */

    if (all_metrics.max_var_span < (int)mod_table[i]->ave_span)
      all_metrics.max_var_span = (int)mod_table[i]->ave_span;
    all_metrics.tot_uncrowd_stmnt += mod_table[i]->num_uncrowd_stmnt;
    

    /*  TED '94--Added max_NCSS calculation.
     */
    if (all_metrics.max_NCSS < mod_table[i]->NCSS)
      all_metrics.max_NCSS = mod_table[i]->NCSS;
    
    if (all_metrics.max_vsubg < mod_table[i]->vsubg)
      all_metrics.max_vsubg = mod_table[i]->vsubg;
    
    if (all_metrics.max_Halv < mod_table[i]->Halv)
      all_metrics.max_Halv = mod_table[i]->Halv;
    
    if (all_metrics.max_Hale < mod_table[i]->Hale)
      all_metrics.max_Hale = mod_table[i]->Hale;
    
    if (all_metrics.max_nesting < mod_table[i]->max_nest)
      all_metrics.max_nesting = mod_table[i]->max_nest;
    
    if (all_metrics.max_fanin < mod_table[i]->fanin)
      all_metrics.max_fanin = mod_table[i]->fanin;
    
    if (all_metrics.max_fanout < mod_table[i]->fanout)
      all_metrics.max_fanout = mod_table[i]->fanout;
    
    if (all_metrics.max_rec_call < mod_table[i]->num_rec_calls)
      all_metrics.max_rec_call = mod_table[i]->num_rec_calls;
    
    if (all_metrics.max_var_mod < mod_table[i]->num_local)
      all_metrics.max_var_mod = mod_table[i]->num_local;
    
    if (mod_table[i]->indent > 0)
      all_metrics.mod_with_indent++;
    
    if (mod_table[i]->num_comments > 0)
      all_metrics.mod_with_comments++;
    
    if (mod_table[i]->horiz_sp > 0)
      all_metrics.mod_with_horiz_sp++;
    
    if (mod_table[i]->vert_sp > 0)
      all_metrics.mod_with_vert_sp++;
    
    if (mod_table[i]->header > 0)
      all_metrics.mod_with_header++;
    
    tot_fanin += mod_table[i]->fanin;
    tot_max_nest += mod_table[i]->max_nest;
    tot_iocalls += mod_table[i]->num_iocall;
    tot_init_vars += mod_table[i]->num_initvars;
    num_params += mod_table[i]->num_params;
    
  }
  
  all_metrics.tot_vars = all_metrics.tot_local + all_metrics.tot_global;
  total_welldecl = all_metrics.tot_welldecl;
  
  if (all_metrics.tot_mods == 0)
  {
    
    all_metrics.ave_LOC = 0.00; 
    all_metrics.ave_NCSS = 0.00; 
    all_metrics.ave_vsubg = 0.00;                
    all_metrics.ave_Halv = 0.00;                    
    all_metrics.ave_Hale = 0.00;                   
    all_metrics.ave_welldecl =0.00;             
    all_metrics.ave_uncrowd_stmnt = 0.00;      
    all_metrics.ave_var_mod      =0.00;          
    all_metrics.ave_num_iocalls  = 0.00;         
    all_metrics.ave_nesting      = 0.00;      
    all_metrics.ave_fanin        = 0.00;   
    all_metrics.ave_num_iocalls  = 0.00;  
    all_metrics.ave_nesting      = 0.00;          
    all_metrics.ave_fanin        = 0.00;          
    all_metrics.ave_comments_per_mod  = 0.00;  
    all_metrics.percent_mods_with_comments = 0.00;
    all_metrics.percent_mods_with_horiz_sp = 0.00; 
    all_metrics.percent_mods_with_vert_sp  = 0.00;  
    all_metrics.percent_mods_with_indent   = 0.00;  
    all_metrics.ave_num_params = 0.00;
    all_metrics.ave_init_vars = 0.00;
    all_metrics.ave_per_mean_vars = 0.00;
    /* Lowther92:*/
    all_metrics.percent_mod_with_header = 0.00;
    /* sm added 01/28/94 from met_dump.c sm */
    all_metrics.ave_var_span = 0.00;
    all_metrics.max_var_span = 0.00;
  }	
  else
  {
    
    all_metrics.ave_LOC    = (float) all_metrics.tot_LOC
      / all_metrics.tot_mods;
    all_metrics.ave_NCSS    = (float) all_metrics.tot_NCSS
      / all_metrics.tot_mods;
    all_metrics.ave_vsubg  = (float) all_metrics.tot_vsubg
      / all_metrics.tot_mods;
    all_metrics.ave_Halv   = (float) all_metrics.tot_Halv
      / all_metrics.tot_mods;
    all_metrics.ave_Hale   = (float) all_metrics.tot_Hale
      / all_metrics.tot_mods;
    all_metrics.ave_welldecl   = (float) all_metrics.tot_welldecl
      / (float) all_metrics.tot_mods;
    all_metrics.ave_uncrowd_stmnt  = (float)(all_metrics.tot_uncrowd_stmnt
                                             / (float) all_metrics.tot_mods);
    all_metrics.ave_var_mod = (float)all_metrics.tot_vars/all_metrics.tot_mods;
    all_metrics.ave_num_iocalls = (float) tot_iocalls / all_metrics.tot_mods;
    all_metrics.ave_nesting = (float) tot_max_nest / all_metrics.tot_mods;
    all_metrics.ave_fanin = (float) tot_fanin / all_metrics.tot_mods;
    all_metrics.ave_num_iocalls = (float) tot_iocalls / all_metrics.tot_mods;
    all_metrics.ave_nesting = (float) tot_max_nest / all_metrics.tot_mods;
    all_metrics.ave_fanin = (float) tot_fanin / all_metrics.tot_mods;
    all_metrics.ave_comments_per_mod = (float) sum_comments
      / (float) all_metrics.tot_mods;
    all_metrics.ave_percent_comments = (float) sum_percents 
      / (float) all_metrics.tot_mods;
    all_metrics.ave_per_mean_vars = (float) sum_per_mean
      / (float) all_metrics.tot_mods;
    all_metrics.percent_mods_with_comments = (float)
      (all_metrics.mod_with_comments / (float) all_metrics.tot_mods) * 100;
    all_metrics.percent_mods_with_horiz_sp = (float)
      (all_metrics.mod_with_horiz_sp / (float) all_metrics.tot_mods) * 100;
    all_metrics.percent_mods_with_vert_sp = (float)
      (all_metrics.mod_with_vert_sp / (float) all_metrics.tot_mods) * 100;
    all_metrics.percent_mods_with_indent = (float)
      (all_metrics.mod_with_indent / (float) all_metrics.tot_mods) * 100;
    all_metrics.ave_num_params = (float)(num_params
                                 / (float)all_metrics.tot_mods);
    all_metrics.ave_init_vars = (float)(tot_init_vars
                                 / (float) all_metrics.tot_mods);
    
    /* Lowther92:*/
    all_metrics.percent_mod_with_header = (float)
       ((float)all_metrics.mod_with_header / (float) all_metrics.tot_mods)
       * 100;
       /* sm 01/28/94 moved from met_dump.c sm */
       all_metrics.ave_var_span /= all_metrics.tot_mods;
    
  } /* end else */
  
  
  if (all_metrics.tot_vars == 0) /*  redefine to prevent divide by zero */
  { 	 
    all_metrics.percent_welldecl = 0.00;
    all_metrics.percent_tot_init_vars = 0.00;
  }
  else
  {
    all_metrics.percent_welldecl = (float)(( all_metrics.tot_welldecl
                                   / (float) all_metrics.tot_vars) * 100);
    all_metrics.percent_tot_init_vars = (float)(( (float)tot_init_vars
                                        / (float) all_metrics.tot_vars) * 100);
  }
}




