/*$Header: hash.c,v 4.0 94/02/01 20:21:28 tedd Exp $*/

/******************************************************************
        Module Name: hash.c

        Preprocessing program for typedef name user-defined
	of Standard ANSI C Parser

        Programmer: Xiaokang Yu
        Date: March 2, 1992
******************************************************************/

#include "hash.h"

/* hash: form hash value for string s */
unsigned hash(s)
char *s;
{
  unsigned hashval;
  
  for (hashval = 0; *s != '\0'; s++)
    hashval = *s + 31 * hashval;
  return hashval % HASHSIZE;
}

/* lookup: look for s in funcalls */
struct func_nlist *lookup(s)
unsigned char *s;
{
  struct func_nlist *np;
  
  for (np = funcalls[hash(s)]; np != NULL; np = np->next)
    if (strcmp(s, np->name) == 0)
      return np;		        /* found */
  return NULL;				/* not found */
}

/* funcname_install: put (name) in funcalls */
struct func_nlist *funcname_install(name)
unsigned char *name;
{
  struct func_nlist *np;
  unsigned hashval;
  
  if ((np = lookup(name)) == NULL) {	/* not found */
    np = (struct func_nlist *) malloc(sizeof(*np));
    if (np == NULL || (np->name = strdup(name)) == NULL)
      return NULL;
    hashval = hash(name);
    np->numb = 1;
    np->next = funcalls[hashval];
    funcalls[hashval] = np;
  }
  else np->numb++;
  
  return np;
}

void func_print()
{
  struct func_nlist *np;
  int index, count = 1;
  
  for (index = 0; index < HASHSIZE; index++)
    for (np = funcalls[index]; np != NULL; np = np->next, count++)
      fprintf(stderr, "%d --- %s - %d\n", count, np->name, np->numb);
}

int fan_in_check(string)
char *string;
{
  struct func_nlist *np;
  int index;
  
  for (index = 0; index < HASHSIZE; index++)
    for (np = funcalls[index]; np != NULL; np = np->next)
      if (strcmp(np->name, string) == 0)
        return np->numb;
  return 0;
}









