# include "stdio.h"
#if defined(__cplusplus)
   extern "C" {
#endif
#if (defined(__cplusplus) || defined(__STDC__))
     extern int yyreject();
     extern int yywrap();
     extern int yylook();
     extern int yyback(int *, int);
     extern int yyinput();
     extern void yyoutput(int);
     extern void yyunput(int);
     extern int yylex();
     extern int yyless(int);
#ifdef LEXDEBUG
     extern void allprint();
     extern void sprint();
#endif
#if defined(__cplusplus)
   }
#endif
#endif	/* __cplusplus or __STDC__ */
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
long yyleng;
long yylenguc;
extern unsigned char yytextarr[];
# ifdef YYCHAR_ARRAY
extern char yytext[];
# else
extern unsigned char yytext[];
# endif
int yyposix_point=0;
int yynls16=0;
int yynls_wchar=0;
char *yylocale = "C C C C C C";
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	int yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/******************************************************************
	Module Name: ansic.l

	Standard ANSI C Scanner
	Reference Book: Third Edition of
		"C - A reference Manual"
		by Samuel P. Harbison & Guy L. Steele Jr.

	Programmer: Xiaokang Yu
	Date: March 2, 1992
******************************************************************/

#include <stdio.h>

/*Lowther93: Minimal detected length identified as an 'indent'*/
#define INDENT_LENGTH 2
/* TED '94--Used in loc_check to help count union lines. */
#define CODE 0
#define COM 1

char yyidentifier[80];
int num_of_preprocessor_directives = 0;
int IS_PROCEDURE_CALL = 0;

# define YYNEWLINE 10
yylex(){
   int nstr; extern int yyprevious;
   while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
   if(yywrap()) return(0); break;
case 1:
		{ loc_check(CODE); return AUTO; }
break;
case 2:
		{ loc_check(CODE); add_operator("BREAK"); return BREAK; }
break;
case 3:
		{ loc_check(CODE); count_keywords(); add_operator("CASE"); 
			  return CASE; }
break;
case 4:
		{ loc_check(CODE); return CHAR; }
break;
case 5:
		{ loc_check(CODE); return CONST; }
break;
case 6:
	{ loc_check(CODE); add_operator("CONTINUE"); return CONTINUE; }
break;
case 7:
	{ loc_check(CODE); count_keywords(); add_operator("DEFAULT"); 
			  return DEFAULT; }
break;
case 8:
		{ loc_check(CODE); add_operator("DO"); return DO; }
break;
case 9:
	{ loc_check(CODE); return DOUBLE; }
break;
case 10:
		{ loc_check(CODE); add_operator("ELSE"); return ELSE; }
break;
case 11:
		{ loc_check(CODE); find_struct = 1; return ENUM; }
break;
case 12:
	{ loc_check(CODE); return EXTERN; }
break;
case 13:
		{ loc_check(CODE); return FLOAT; }
break;
case 14:
		{ loc_check(CODE); count_keywords(); add_operator("FOR"); 
			    in_exp = 1; return FOR; }
break;
case 15:
		{ loc_check(CODE); count_keywords(); add_operator("GOTO");
			  return GOTO; }
break;
case 16:
		{ loc_check(CODE); count_keywords(); add_operator("IF"); 
			    in_exp = 1; return IF; }
break;
case 17:
		{ loc_check(CODE); return INT; }
break;
case 18:
		{ loc_check(CODE); return LONG; }
break;
case 19:
		{ loc_check(CODE); macro_call(); }
break;
case 20:
	{ loc_check(CODE); return REGISTER; }
break;
case 21:
	{ loc_check(CODE); add_operator("RETURN"); return RETURN; }
break;
case 22:
		{ loc_check(CODE); return SHORT; }
break;
case 23:
	{ loc_check(CODE); return SIGNED; }
break;
case 24:
	{ loc_check(CODE); add_operator("SIZEOF"); return SIZEOF; }
break;
case 25:
	{ loc_check(CODE); return STATIC; }
break;
case 26:
	{ loc_check(CODE); find_struct = 1; return STRUCT; }
break;
case 27:
	{ loc_check(CODE); count_keywords(); add_operator("SWITCH"); 
			    in_exp = 1; return SWITCH; }
break;
case 28:
	{ loc_check(CODE); return TYPEDEF; }
break;
case 29:
		{ loc_check(CODE); find_struct = 1; return UNION; }
break;
case 30:
	{ loc_check(CODE); return UNSIGNED; }
break;
case 31:
		{ loc_check(CODE); return VOID; }
break;
case 32:
	{ loc_check(CODE); return VOLATILE; }
break;
case 33:
		{ loc_check(CODE); count_keywords(); add_operator("WHILE"); 
			    in_exp = 1; return WHILE; }
break;
case 34:
	{ loc_check(CODE); return(check_type()); }
break;
case 35:
	{ loc_check(CODE); change_operand_tree(yytext); 
                          return CONSTANT; }
break;
case 36:
{ loc_check(CODE); change_operand_tree(yytext); return STRING; }
break;
case 37:
		{ loc_check(CODE); add_operator("+="); return ASSIGN_OP; }
break;
case 38:
		{ loc_check(CODE); add_operator("-="); return ASSIGN_OP; }
break;
case 39:
		{ loc_check(CODE); add_operator("*="); return ASSIGN_OP; }
break;
case 40:
		{ loc_check(CODE); add_operator("/="); return ASSIGN_OP; }
break;
case 41:
		{ loc_check(CODE); add_operator("%="); return ASSIGN_OP; }
break;
case 42:
		{ loc_check(CODE); add_operator("<<="); return ASSIGN_OP; }
break;
case 43:
		{ loc_check(CODE); add_operator(">>="); return ASSIGN_OP; }
break;
case 44:
		{ loc_check(CODE); add_operator("&="); return ASSIGN_OP; }
break;
case 45:
		{ loc_check(CODE); add_operator("^="); return ASSIGN_OP; }
break;
case 46:
		{ loc_check(CODE); add_operator("|="); return ASSIGN_OP; }
break;
case 47:
		{ loc_check(CODE); add_operator("=="); return EQUALITY_OP; }
break;
case 48:
		{ loc_check(CODE); add_operator("!="); return EQUALITY_OP; }
break;
case 49:
		{ loc_check(CODE); add_operator("<"); return RELATIONAL_OP; }
break;
case 50:
		{ loc_check(CODE); add_operator(">"); return RELATIONAL_OP; }
break;
case 51:
		{ loc_check(CODE); add_operator("<="); return RELATIONAL_OP; }
break;
case 52:
		{ loc_check(CODE); add_operator(">="); return RELATIONAL_OP; }
break;
case 53:
		{ loc_check(CODE); add_operator("<<"); return SHIFT_OP; }
break;
case 54:
		{ loc_check(CODE); add_operator(">>"); return SHIFT_OP; }
break;
case 55:
		{ loc_check(CODE); add_operator(";"); statement(); return ';'; }
break;
case 56:
	 	{ loc_check(CODE); add_operator(","); return ','; }
break;
case 57:
		{ loc_check(CODE); add_operator("{"); check_space(); 
                          return '{'; }
break;
case 58:
		{ loc_check(CODE); return '}'; }
break;
case 59:
		{ loc_check(CODE); add_operator("("); p_cnt ++; return '('; }
break;
case 60:
		{ loc_check(CODE); if ((--p_cnt) == 0) in_exp = 0; return ')'; }
break;
case 61:
		{ loc_check(CODE); add_operator("*"); return '*'; }
break;
case 62:
		{ loc_check(CODE); add_operator("/"); return '/'; }
break;
case 63:
		{ loc_check(CODE); add_operator("%"); return '%'; }
break;
case 64:
		{ loc_check(CODE); gab = 1; add_operator("["); return '['; }
break;
case 65:
		{ loc_check(CODE); gab = 0; return ']'; }
break;
case 66:
		{ loc_check(CODE); add_operator(":"); return ':'; }
break;
case 67:
		{ loc_check(CODE); add_operator("="); return '='; }
break;
case 68:
		{ loc_check(CODE); count_keywords(); add_operator("?"); 
                          return '?'; }
break;
case 69:
		{ loc_check(CODE); add_operator("-"); return '-'; }
break;
case 70:
		{ loc_check(CODE); add_operator("+"); return '+'; }
break;
case 71:
		{ loc_check(CODE); add_operator("!"); return '!'; }
break;
case 72:
		{ loc_check(CODE); add_operator("~"); return '~'; }
break;
case 73:
		{ loc_check(CODE); add_operator("&"); return '&'; }
break;
case 74:
		{ loc_check(CODE); add_operator("|"); return '|'; }
break;
case 75:
		{ loc_check(CODE); add_operator("."); return '.'; }
break;
case 76:
		{ loc_check(CODE); add_operator("^"); return '^'; }
break;
case 77:
		{ loc_check(CODE); add_operator("++"); return INCREMENT; }
break;
case 78:
		{ loc_check(CODE); add_operator("--"); return DECREMENT; }
break;
case 79:
		{ loc_check(CODE); add_operator("||"); count_keywords(); 
                          return OR; }
break;
case 80:
		{ loc_check(CODE); add_operator("&&"); count_keywords(); 
                          return AND; }
break;
case 81:
		{ loc_check(CODE); add_operator("->"); 
                          return INDIRECT_SELECTION; }
break;
case 82:
		{ loc_check(CODE); return ELIPSIS; }
break;
case 83:
		{ ; }
break;
case 84:
		{ loc_check(COM); comment_process(); }
break;
case 85:
		{ loc_check(CODE); definitions(); }
break;
case 86:
{ external_file(); definitions(); }
break;
case 87:
{ blank(); }
break;
case 88:
{ horizontal_spacing(); }
break;
case 89:
{ vertical_spacing(); }
break;
case 90:
	{ newline(); }
break;
case 91:
		{ ; }
break;
case 92:
		{ ; }
break;
case 93:
		{ fprintf(stderr,"line %d: illegal character %s\n", yylineno, yytext); }
break;
case -1:
break;
default:
   fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

#ifndef __cplusplus
static void __yy__unused() { main(); }
#endif

/*    comment

      called by : lex.
      calls     : comment_lines in ps-code

      This procedure removes and counts the comment lines from the input
      code.

*/

/*  TED '94--rewrote comment_process so it doesn't count
 *	     blanks lines in a comment, only comment lines
 *           with text on them.
 */

comment_process()
{
  char c, c1;
  int lines = 0;     /* number of lines in comment */
  int empty_line = 0; /* flag to show when comment line is empty */
  
  while (c = input()) 
  {

    if(!(isspace(c)))
    {
      /* line busy (has something on it) */
      empty_line = 0;

      /* check to see if comment is ended */
      if(c == '*')
      {
	c1 = input();

	if(c1 == '/')
	  break;
	else
	  unput(c1);
      }
    }


    /* found a new comment line */
    if(c == '\n')
    {
      /* increment line count if there is something on this line */
      if(!empty_line)
        lines++;

      /* reset busy line flag */
      empty_line = 1;
    }

  }

  comment_lines(lines + 1);
}

/*---------------------------------------------------------------------
|                                                                     |
| Module Name: last_comment_check                      date: 1/31/94  |
|                                                                     |
| Programmer:  Dan Ash                    last modification: 1/31/94  |
|                                                                     |
| Description: checks for comments following the closing '}' of a     |
|              module.                                                |
|____________________________________________________________________*/

void last_comment_check(void)
{
  char current, next;

  while (isspace(current = input()) && current != '\n');

  if (current != '/')   /* if not a / then no comments */
  {
    unput(current);     /* replace input to stream */
    return;
  }
  else
  {
    next = input();     /* if not followed by a * then no comment */
    if (next != '*')
    {
      unput(next);      /* replace both to stream */
      unput(current);
      return;
    }
  }

  loc_check(COM);       /* found comment */
  comment_process();
} 

/*     definitions

       With a preprocessor directive, this procedure will read until
       a newline is found or a back slash.  If a back slash is encountered
       the nest line will be considered as a part of this line.

*/

definitions()
{
  char c;
  int count=0;
  
 loop:	for(c=input(); !(c=='\n' && count==0) ; c=input())
   switch(c)
   {
     case '\\': count = 1; break;
     default: count = 0; break;
   }
  num_of_preprocessor_directives ++;
  unput('\n');
}


/*     macro_call

       called by : lex.

       This procedure removes the macro RCSID 
*/

macro_call()
{
  char c;
  while( (c=input()) != '\n' );
  unput( '\n' );
}


/*     type_in

       called by : check_type

       This procedure adds a new type name into the array
*/


type_in(s)
char *s;
{
  if( tn_count > 256 )
    fprintf(stderr, "***** error typedef array is full *****\n");
  strcpy(TN[tn_count++].type_name, s);
  return;
}

/*      check_type 

        called by : lex.
        returns   : identifier type.

        This procedure takes an identifier and with the next two non white
        characters decides if the identifier is an identifier or a type
        name.  This procedure will also see if the identifier is the start
        of a procedure.
*/

check_type()
{
  int i;
  char c, c1;
  int rets = 0, rets1 = 0;
  
  strcpy( yyidentifier, yytext );
  
  while (isspace(c = input()))
    if( c== '\n')
      rets++;
  i = 0;
  while (isspace(c1 = input()))
  {
    i++;
    if( c1=='\n')
      rets1++;
  }
  unput(c1);
  while(rets1>0)
  {
    rets1--;
    unput('\n');
  }
  if (i > 0)
    unput(' ');
  unput(c);
  while(rets>0)
  {
    rets--;
    unput('\n');
  }
  unput(' ');
  
  if(c == '(')
    if(where_in_code == WHERE_GLOBAL)
      start_proc();
    else
    {
      if(where_in_code == WHERE_CODE)
        statement_list_identifiers(); 
      IS_PROCEDURE_CALL++;
    }


  for(i = 0; i < tn_count; i++)
    if(strcmp(TN[i].type_name, yytext) == 0)
      return(TYPEDEF_NAME);
  if (find_struct == 1) {
    find_struct = 0;
    return(IDENTIFIER);
  }
  
  if ((c == '_' || isalpha(c)) || ((c == '*') && (c1 == ')'))) {
    type_in(yytext);
    return(TYPEDEF_NAME);
  }
  else {
    if ((in_stmt == 1) && (c == ')') && (isalnum(c1) || (c1 == '_'))) {
      if (in_exp == 0) {
        type_in(yytext);
        return(TYPEDEF_NAME);
      }
      else
        return(IDENTIFIER);
    }
    else {
      if ((c == '*') && (isalnum(c1))) {
        if (in_stmt == 1)
          return(IDENTIFIER);
        else {
          type_in(yytext);
          return(TYPEDEF_NAME);
        }
      }
      else
        return (IDENTIFIER); 
    }
  }
}

/*     newline

       called by : lex.
       calls     : indentation, vertical_spacing, and lines_of_code.  All
       of which are in ps-code.

       This procedure reads in the white space at the start of a new line
       and checks for indentation and vertical_spacing.  The first non-
       white space character that is found will increment the number of
       lines of code for the procedure.
*/

#include <ctype.h>

/* Lowther93: Check for indention on a line starting with a '{'*/

check_space()
{
  int space = 0;
  int c;
  int newline_flag = 0;
  
  while(isspace(c = input()))
  {
    space++;
    if (c == '\t') space = INDENT_LENGTH;  /* a tab is always big enough */

    /* DEA - 93: if it finds a newline character then set the newline flag */

    if(c == '\n')
      newline_flag = 1;
  }
  unput(c);

  /* DEA - 93: if newline character is true, then increment lines of code */

  if(newline_flag) 
    lines_of_code();

  if(space >= INDENT_LENGTH) indentation();
}

newline()
{
  int space = 0;
  int c;
  int eof_flag = 0;
  
  for(c = input(); isspace(c); c = input())
  {
    switch( c )
    {
    case '\t': indentation();
      break;
    case ' ': space++;  /* lowther93: count up spaces for indentation check */
      break;
    case '\n':
    case '\v':
    case '\f': vertical_spacing();
      break;
    }
  }

  /* DEA - 93: If character is eof character, then set eof flag to 1 */

  if(c == 0)
    eof_flag = 1;
  else
    unput(c);                       /* Lowther93: Drop the last detected space
                                     character from the above case
                                     */

  /* Lowther93: The indent space is set here, it should be a #define. */
  
  if( space >= INDENT_LENGTH ) indentation();
  
  /* DEA - 93:  if eof flag NOT set then increment lines of code */

  if(!eof_flag)
    lines_of_code();
}

/*    blank

      called by : lex.
      calls     : horizontal_spacing.

      This procedure is called when a white space is found in the middle
      of a line of code.  It then checks for two or more white space
      within the code.  This check is for horizontal_spacing.
*/

blank()
{
  char c;
  if((c = input()) == ' ')
    horizontal_spacing();
  else
    unput(c);
}
int yyvstop[] = {
0,

93,
0,

88,
93,
0,

90,
0,

89,
93,
0,

87,
93,
0,

71,
93,
0,

93,
0,

85,
93,
0,

63,
93,
0,

73,
93,
0,

93,
0,

59,
93,
0,

60,
93,
0,

61,
93,
0,

70,
93,
0,

56,
93,
0,

69,
93,
0,

75,
93,
0,

62,
93,
0,

35,
93,
0,

35,
93,
0,

66,
93,
0,

55,
93,
0,

49,
93,
0,

67,
93,
0,

50,
93,
0,

68,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

64,
93,
0,

83,
93,
0,

65,
93,
0,

76,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
93,
0,

34,
89,
93,
0,

34,
93,
0,

57,
93,
0,

74,
93,
0,

58,
93,
0,

72,
93,
0,

48,
0,

36,
0,

41,
0,

80,
0,

44,
0,

39,
0,

77,
0,

37,
0,

78,
0,

38,
0,

81,
0,

35,
0,

84,
0,

40,
0,

35,
0,

35,
0,

35,
0,

35,
0,

35,
0,

53,
0,

51,
0,

47,
0,

52,
0,

54,
0,

34,
0,

34,
0,

45,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

8,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

16,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

46,
0,

79,
0,

36,
0,

35,
0,

35,
92,
0,

35,
91,
0,

82,
0,

35,
0,

35,
0,

42,
0,

43,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

14,
34,
0,

34,
0,

17,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

35,
0,

34,
0,

1,
34,
0,

34,
0,

3,
34,
0,

4,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

10,
34,
0,

11,
34,
0,

34,
0,

34,
0,

15,
34,
0,

18,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

31,
34,
0,

34,
0,

34,
0,

19,
34,
0,

2,
34,
0,

5,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

13,
34,
0,

34,
0,

34,
0,

22,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

29,
34,
0,

34,
0,

34,
0,

33,
34,
0,

34,
0,

34,
0,

9,
34,
0,

12,
34,
0,

34,
0,

21,
34,
0,

23,
34,
0,

24,
34,
0,

25,
34,
0,

26,
34,
0,

27,
34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

7,
34,
0,

34,
0,

28,
34,
0,

34,
0,

34,
0,

6,
34,
0,

20,
34,
0,

30,
34,
0,

32,
34,
0,

86,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
{0,0},	{0,0},	{1,3},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{1,4},	{1,5},	
{0,0},	{1,6},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{1,7},	{1,8},	{1,9},	
{1,10},	{0,0},	{1,11},	{1,12},	
{1,13},	{1,14},	{1,15},	{1,16},	
{1,17},	{1,18},	{1,19},	{1,20},	
{1,21},	{1,22},	{1,23},	{12,62},	
{74,131},	{31,57},	{0,0},	{17,69},	
{21,76},	{1,23},	{31,92},	{1,24},	
{1,25},	{1,26},	{1,27},	{1,28},	
{1,29},	{8,56},	{1,30},	{11,61},	
{16,68},	{27,88},	{1,30},	{1,30},	
{1,30},	{17,70},	{12,63},	{21,77},	
{32,93},	{1,31},	{26,86},	{26,87},	
{28,89},	{28,90},	{36,94},	{1,32},	
{86,136},	{90,137},	{1,30},	{138,174},	
{93,138},	{1,30},	{0,0},	{0,0},	
{1,33},	{1,34},	{1,35},	{1,36},	
{1,30},	{19,71},	{1,37},	{1,38},	
{1,39},	{1,40},	{1,41},	{1,42},	
{1,43},	{57,59},	{1,44},	{10,60},	
{46,111},	{1,45},	{51,119},	{1,30},	
{53,120},	{19,72},	{19,73},	{1,46},	
{1,47},	{1,48},	{1,49},	{1,50},	
{1,51},	{38,96},	{37,95},	{43,107},	
{1,52},	{1,53},	{1,54},	{1,55},	
{2,8},	{45,110},	{2,10},	{39,97},	
{2,11},	{2,12},	{40,100},	{2,14},	
{2,15},	{2,16},	{39,98},	{2,18},	
{2,19},	{2,20},	{2,21},	{42,105},	
{40,101},	{39,99},	{42,106},	{41,102},	
{48,116},	{41,103},	{49,117},	{50,118},	
{60,125},	{2,24},	{2,25},	{2,26},	
{2,27},	{2,28},	{20,74},	{41,104},	
{20,75},	{20,75},	{20,75},	{20,75},	
{20,75},	{20,75},	{20,75},	{20,75},	
{20,75},	{20,75},	{44,108},	{95,139},	
{96,140},	{97,141},	{98,142},	{53,121},	
{99,143},	{2,32},	{44,109},	{100,144},	
{101,145},	{102,146},	{103,147},	{82,126},	
{104,148},	{105,149},	{2,33},	{2,34},	
{2,35},	{2,36},	{2,30},	{83,126},	
{106,150},	{2,38},	{2,39},	{2,40},	
{2,41},	{9,57},	{2,43},	{107,151},	
{2,44},	{47,112},	{47,113},	{2,45},	
{65,0},	{9,57},	{9,57},	{109,152},	
{9,57},	{2,46},	{2,47},	{2,48},	
{2,49},	{47,114},	{2,51},	{82,126},	
{47,115},	{59,122},	{2,52},	{2,53},	
{2,54},	{2,55},	{66,0},	{83,126},	
{110,153},	{92,0},	{112,156},	{111,154},	
{9,57},	{113,157},	{9,58},	{59,123},	
{59,123},	{65,127},	{115,161},	{9,57},	
{114,159},	{116,162},	{118,165},	{9,57},	
{111,155},	{118,166},	{119,167},	{122,59},	
{9,57},	{9,57},	{125,169},	{13,64},	
{113,158},	{139,175},	{117,163},	{66,128},	
{9,57},	{114,160},	{92,0},	{13,64},	
{13,0},	{13,65},	{13,64},	{9,57},	
{117,164},	{9,57},	{129,0},	{140,176},	
{135,82},	{9,57},	{9,57},	{9,57},	
{13,66},	{123,168},	{123,168},	{141,177},	
{9,57},	{135,83},	{142,178},	{59,59},	
{143,179},	{143,180},	{13,64},	{144,181},	
{13,64},	{9,57},	{145,182},	{146,183},	
{9,57},	{13,0},	{65,67},	{147,184},	
{9,59},	{13,64},	{148,185},	{134,126},	
{149,186},	{9,57},	{13,64},	{13,64},	
{135,82},	{134,126},	{9,57},	{151,187},	
{129,170},	{129,170},	{13,64},	{59,124},	
{66,67},	{135,83},	{9,57},	{92,67},	
{153,188},	{13,64},	{154,189},	{13,64},	
{155,190},	{123,59},	{9,57},	{13,64},	
{13,64},	{13,64},	{156,191},	{157,192},	
{158,193},	{159,194},	{13,64},	{134,126},	
{160,195},	{161,196},	{162,197},	{163,198},	
{164,199},	{134,126},	{165,200},	{13,64},	
{166,201},	{167,202},	{13,64},	{168,59},	
{169,203},	{170,0},	{13,67},	{174,204},	
{176,205},	{179,206},	{180,207},	{13,64},	
{129,67},	{181,208},	{182,209},	{185,210},	
{13,64},	{186,211},	{189,212},	{190,213},	
{191,214},	{173,126},	{192,215},	{193,216},	
{13,64},	{194,217},	{195,218},	{173,126},	
{196,219},	{197,220},	{198,221},	{22,78},	
{13,64},	{22,79},	{22,79},	{22,79},	
{22,79},	{22,79},	{22,79},	{22,79},	
{22,79},	{22,80},	{22,80},	{78,78},	
{78,78},	{78,78},	{78,78},	{78,78},	
{78,78},	{78,78},	{78,78},	{78,78},	
{78,78},	{173,126},	{22,81},	{199,222},	
{201,223},	{202,224},	{203,225},	{173,126},	
{207,226},	{22,82},	{208,227},	{209,228},	
{210,229},	{212,230},	{213,231},	{215,232},	
{216,233},	{217,234},	{22,83},	{218,235},	
{219,236},	{22,84},	{23,78},	{220,237},	
{23,85},	{23,85},	{23,85},	{23,85},	
{23,85},	{23,85},	{23,85},	{23,85},	
{23,85},	{23,85},	{22,81},	{170,67},	
{222,238},	{223,239},	{124,124},	{124,124},	
{225,240},	{22,82},	{226,241},	{227,242},	
{230,243},	{23,81},	{124,124},	{237,244},	
{238,245},	{239,246},	{22,83},	{240,247},	
{23,82},	{22,84},	{241,248},	{124,124},	
{243,249},	{245,250},	{246,251},	{124,124},	
{124,124},	{23,83},	{79,79},	{79,79},	
{79,79},	{79,79},	{79,79},	{79,79},	
{79,79},	{79,79},	{79,80},	{79,80},	
{252,253},	{0,0},	{0,0},	{0,0},	
{0,0},	{23,81},	{0,0},	{0,0},	
{0,0},	{247,252},	{124,59},	{0,0},	
{23,82},	{0,0},	{0,0},	{124,124},	
{0,0},	{0,0},	{0,0},	{0,0},	
{124,124},	{23,83},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{247,252},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{0,0},	{0,0},	{0,0},	
{0,0},	{30,91},	{0,0},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{30,91},	{30,91},	{30,91},	
{30,91},	{64,64},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{64,64},	{64,0},	{0,0},	
{64,64},	{0,0},	{75,75},	{75,75},	
{75,75},	{75,75},	{75,75},	{75,75},	
{75,75},	{75,75},	{75,75},	{75,75},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{64,64},	{0,0},	{64,64},	{75,132},	
{75,126},	{0,0},	{0,0},	{64,126},	
{0,0},	{0,0},	{75,126},	{64,64},	
{0,0},	{0,0},	{0,0},	{0,0},	
{64,64},	{64,64},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{64,64},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{64,64},	
{0,0},	{64,64},	{0,0},	{75,132},	
{75,126},	{64,64},	{64,64},	{64,64},	
{0,0},	{0,0},	{75,126},	{0,0},	
{64,64},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{64,64},	{0,0},	{0,0},	
{64,64},	{0,0},	{0,0},	{0,0},	
{64,67},	{0,0},	{0,0},	{0,0},	
{0,0},	{64,64},	{0,0},	{0,0},	
{0,0},	{0,0},	{64,64},	{0,0},	
{0,0},	{0,0},	{67,64},	{0,0},	
{0,0},	{0,0},	{64,64},	{67,64},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{64,64},	{0,0},	
{67,129},	{67,129},	{67,129},	{67,129},	
{67,129},	{67,129},	{67,129},	{67,129},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{80,78},	{67,64},	
{80,80},	{80,80},	{80,80},	{80,80},	
{80,80},	{80,80},	{80,80},	{80,80},	
{80,80},	{80,80},	{133,134},	{133,134},	
{133,134},	{133,134},	{133,134},	{133,134},	
{133,134},	{133,134},	{133,134},	{133,134},	
{0,0},	{80,81},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{67,64},	{0,0},	{0,0},	{0,0},	
{0,0},	{67,64},	{67,64},	{0,0},	
{0,0},	{0,0},	{67,64},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{67,64},	{0,0},	
{0,0},	{0,0},	{67,64},	{0,0},	
{67,64},	{80,81},	{67,64},	{81,133},	
{67,130},	{81,133},	{0,0},	{0,0},	
{81,134},	{81,134},	{81,134},	{81,134},	
{81,134},	{81,134},	{81,134},	{81,134},	
{81,134},	{81,134},	{84,135},	{84,135},	
{84,135},	{84,135},	{84,135},	{84,135},	
{84,135},	{84,135},	{84,135},	{84,135},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{84,135},	
{84,135},	{84,135},	{84,135},	{84,135},	
{84,135},	{130,171},	{130,171},	{130,171},	
{130,171},	{130,171},	{130,171},	{130,171},	
{130,171},	{130,171},	{130,171},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{130,171},	{130,171},	
{130,171},	{130,171},	{130,171},	{130,171},	
{171,0},	{0,0},	{0,0},	{84,135},	
{84,135},	{84,135},	{84,135},	{84,135},	
{84,135},	{132,172},	{0,0},	{132,172},	
{0,0},	{0,0},	{132,173},	{132,173},	
{132,173},	{132,173},	{132,173},	{132,173},	
{132,173},	{132,173},	{132,173},	{132,173},	
{0,0},	{0,0},	{130,171},	{130,171},	
{130,171},	{130,171},	{130,171},	{130,171},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{171,171},	{171,171},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{171,171},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{171,171},	
{0,0},	{0,0},	{0,0},	{171,171},	
{171,171},	{172,173},	{172,173},	{172,173},	
{172,173},	{172,173},	{172,173},	{172,173},	
{172,173},	{172,173},	{172,173},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{0,0},	{0,0},	
{0,0},	{0,0},	{171,67},	{0,0},	
{0,0},	{0,0},	{0,0},	{171,171},	
{0,0},	{0,0},	{0,0},	{0,0},	
{171,171},	{0,0},	{0,0},	{0,0},	
{0,0}};
struct yysvf yysvec[] = {
{0,	0,	0},
{-1,	0,		0},	
{-95,	yysvec+1,	0},	
{0,	0,		yyvstop+1},
{0,	0,		yyvstop+3},
{0,	0,		yyvstop+6},
{0,	0,		yyvstop+8},
{0,	0,		yyvstop+11},
{4,	0,		yyvstop+14},
{-196,	0,		yyvstop+17},
{2,	0,		yyvstop+19},
{6,	0,		yyvstop+22},
{13,	0,		yyvstop+25},
{-246,	0,		yyvstop+28},
{0,	0,		yyvstop+30},
{0,	0,		yyvstop+33},
{7,	0,		yyvstop+36},
{12,	0,		yyvstop+39},
{0,	0,		yyvstop+42},
{52,	0,		yyvstop+45},
{112,	0,		yyvstop+48},
{14,	0,		yyvstop+51},
{317,	0,		yyvstop+54},
{360,	0,		yyvstop+57},
{0,	0,		yyvstop+60},
{0,	0,		yyvstop+63},
{18,	0,		yyvstop+66},
{8,	0,		yyvstop+69},
{19,	0,		yyvstop+72},
{0,	0,		yyvstop+75},
{430,	0,		yyvstop+78},
{19,	yysvec+30,	yyvstop+81},
{9,	yysvec+30,	yyvstop+84},
{0,	0,		yyvstop+87},
{0,	0,		yyvstop+90},
{0,	0,		yyvstop+93},
{21,	0,		yyvstop+96},
{5,	yysvec+30,	yyvstop+99},
{7,	yysvec+30,	yyvstop+102},
{34,	yysvec+30,	yyvstop+105},
{33,	yysvec+30,	yyvstop+108},
{39,	yysvec+30,	yyvstop+111},
{35,	yysvec+30,	yyvstop+114},
{12,	yysvec+30,	yyvstop+117},
{68,	yysvec+30,	yyvstop+120},
{18,	yysvec+30,	yyvstop+123},
{7,	yysvec+30,	yyvstop+126},
{97,	yysvec+30,	yyvstop+129},
{27,	yysvec+30,	yyvstop+132},
{40,	yysvec+30,	yyvstop+135},
{40,	yysvec+30,	yyvstop+138},
{6,	yysvec+30,	yyvstop+142},
{0,	0,		yyvstop+145},
{51,	0,		yyvstop+148},
{0,	0,		yyvstop+151},
{0,	0,		yyvstop+154},
{0,	0,		yyvstop+157},
{-13,	yysvec+9,	0},	
{0,	0,		yyvstop+159},
{-183,	yysvec+9,	0},	
{42,	0,		0},	
{0,	0,		yyvstop+161},
{0,	0,		yyvstop+163},
{0,	0,		yyvstop+165},
{-552,	0,		0},	
{-194,	yysvec+64,	0},	
{-212,	yysvec+64,	0},	
{624,	0,		0},	
{0,	0,		yyvstop+167},
{0,	0,		yyvstop+169},
{0,	0,		yyvstop+171},
{0,	0,		yyvstop+173},
{0,	0,		yyvstop+175},
{0,	0,		yyvstop+177},
{6,	0,		0},	
{518,	0,		yyvstop+179},
{0,	0,		yyvstop+181},
{0,	0,		yyvstop+183},
{327,	yysvec+75,	yyvstop+185},
{398,	yysvec+23,	yyvstop+187},
{640,	0,		0},	
{700,	0,		0},	
{98,	0,		yyvstop+189},
{115,	0,		yyvstop+191},
{710,	0,		0},	
{0,	yysvec+23,	yyvstop+193},
{23,	0,		yyvstop+195},
{0,	0,		yyvstop+197},
{0,	0,		yyvstop+199},
{0,	0,		yyvstop+201},
{24,	0,		yyvstop+203},
{0,	yysvec+30,	yyvstop+205},
{-215,	yysvec+64,	0},	
{5,	yysvec+30,	yyvstop+207},
{0,	0,		yyvstop+209},
{55,	yysvec+30,	yyvstop+211},
{71,	yysvec+30,	yyvstop+213},
{58,	yysvec+30,	yyvstop+215},
{77,	yysvec+30,	yyvstop+217},
{66,	yysvec+30,	yyvstop+219},
{77,	yysvec+30,	yyvstop+221},
{63,	yysvec+30,	yyvstop+223},
{66,	yysvec+30,	yyvstop+226},
{65,	yysvec+30,	yyvstop+228},
{68,	yysvec+30,	yyvstop+230},
{74,	yysvec+30,	yyvstop+232},
{78,	yysvec+30,	yyvstop+234},
{83,	yysvec+30,	yyvstop+236},
{0,	yysvec+30,	yyvstop+238},
{91,	yysvec+30,	yyvstop+241},
{114,	yysvec+30,	yyvstop+243},
{124,	yysvec+30,	yyvstop+245},
{115,	yysvec+30,	yyvstop+247},
{126,	yysvec+30,	yyvstop+249},
{139,	yysvec+30,	yyvstop+251},
{129,	yysvec+30,	yyvstop+253},
{125,	yysvec+30,	yyvstop+255},
{145,	yysvec+30,	yyvstop+257},
{133,	yysvec+30,	yyvstop+259},
{137,	yysvec+30,	yyvstop+261},
{0,	0,		yyvstop+263},
{0,	0,		yyvstop+265},
{-151,	yysvec+9,	yyvstop+267},
{-221,	yysvec+9,	0},	
{-374,	yysvec+9,	0},	
{147,	0,		0},	
{0,	0,		yyvstop+269},
{0,	0,		yyvstop+271},
{0,	0,		yyvstop+274},
{-252,	yysvec+64,	0},	
{733,	0,		0},	
{0,	0,		yyvstop+277},
{770,	0,		0},	
{650,	0,		0},	
{221,	yysvec+133,	yyvstop+279},
{188,	yysvec+84,	yyvstop+281},
{0,	0,		yyvstop+283},
{0,	0,		yyvstop+285},
{14,	yysvec+30,	yyvstop+287},
{138,	yysvec+30,	yyvstop+289},
{166,	yysvec+30,	yyvstop+291},
{170,	yysvec+30,	yyvstop+293},
{160,	yysvec+30,	yyvstop+295},
{161,	yysvec+30,	yyvstop+297},
{182,	yysvec+30,	yyvstop+299},
{184,	yysvec+30,	yyvstop+301},
{182,	yysvec+30,	yyvstop+303},
{178,	yysvec+30,	yyvstop+305},
{189,	yysvec+30,	yyvstop+307},
{195,	yysvec+30,	yyvstop+309},
{0,	yysvec+30,	yyvstop+311},
{188,	yysvec+30,	yyvstop+314},
{0,	yysvec+30,	yyvstop+316},
{205,	yysvec+30,	yyvstop+319},
{205,	yysvec+30,	yyvstop+321},
{195,	yysvec+30,	yyvstop+323},
{204,	yysvec+30,	yyvstop+325},
{209,	yysvec+30,	yyvstop+327},
{219,	yysvec+30,	yyvstop+329},
{205,	yysvec+30,	yyvstop+331},
{207,	yysvec+30,	yyvstop+333},
{209,	yysvec+30,	yyvstop+335},
{225,	yysvec+30,	yyvstop+337},
{216,	yysvec+30,	yyvstop+339},
{223,	yysvec+30,	yyvstop+341},
{230,	yysvec+30,	yyvstop+343},
{235,	yysvec+30,	yyvstop+345},
{225,	yysvec+30,	yyvstop+347},
{-243,	yysvec+9,	0},	
{228,	0,		0},	
{-327,	yysvec+64,	0},	
{-794,	yysvec+64,	0},	
{817,	0,		0},	
{283,	yysvec+172,	yyvstop+349},
{271,	yysvec+30,	yyvstop+351},
{0,	yysvec+30,	yyvstop+353},
{233,	yysvec+30,	yyvstop+356},
{0,	yysvec+30,	yyvstop+358},
{0,	yysvec+30,	yyvstop+361},
{225,	yysvec+30,	yyvstop+364},
{237,	yysvec+30,	yyvstop+366},
{228,	yysvec+30,	yyvstop+368},
{238,	yysvec+30,	yyvstop+370},
{0,	yysvec+30,	yyvstop+372},
{0,	yysvec+30,	yyvstop+375},
{233,	yysvec+30,	yyvstop+378},
{233,	yysvec+30,	yyvstop+380},
{0,	yysvec+30,	yyvstop+382},
{0,	yysvec+30,	yyvstop+385},
{235,	yysvec+30,	yyvstop+388},
{237,	yysvec+30,	yyvstop+390},
{236,	yysvec+30,	yyvstop+392},
{253,	yysvec+30,	yyvstop+394},
{244,	yysvec+30,	yyvstop+396},
{252,	yysvec+30,	yyvstop+398},
{259,	yysvec+30,	yyvstop+400},
{261,	yysvec+30,	yyvstop+402},
{261,	yysvec+30,	yyvstop+404},
{252,	yysvec+30,	yyvstop+406},
{284,	yysvec+30,	yyvstop+408},
{0,	yysvec+30,	yyvstop+410},
{272,	yysvec+30,	yyvstop+413},
{288,	yysvec+30,	yyvstop+415},
{273,	0,		0},	
{0,	yysvec+30,	yyvstop+417},
{0,	yysvec+30,	yyvstop+420},
{0,	yysvec+30,	yyvstop+423},
{282,	yysvec+30,	yyvstop+426},
{286,	yysvec+30,	yyvstop+428},
{294,	yysvec+30,	yyvstop+430},
{286,	yysvec+30,	yyvstop+432},
{0,	yysvec+30,	yyvstop+434},
{281,	yysvec+30,	yyvstop+437},
{288,	yysvec+30,	yyvstop+439},
{0,	yysvec+30,	yyvstop+441},
{299,	yysvec+30,	yyvstop+444},
{298,	yysvec+30,	yyvstop+446},
{302,	yysvec+30,	yyvstop+448},
{287,	yysvec+30,	yyvstop+450},
{300,	yysvec+30,	yyvstop+452},
{306,	yysvec+30,	yyvstop+454},
{0,	yysvec+30,	yyvstop+456},
{310,	yysvec+30,	yyvstop+459},
{316,	yysvec+30,	yyvstop+461},
{0,	yysvec+30,	yyvstop+463},
{324,	0,		0},	
{309,	yysvec+30,	yyvstop+466},
{311,	yysvec+30,	yyvstop+468},
{0,	yysvec+30,	yyvstop+470},
{0,	yysvec+30,	yyvstop+473},
{327,	yysvec+30,	yyvstop+476},
{0,	yysvec+30,	yyvstop+478},
{0,	yysvec+30,	yyvstop+481},
{0,	yysvec+30,	yyvstop+484},
{0,	yysvec+30,	yyvstop+487},
{0,	yysvec+30,	yyvstop+490},
{0,	yysvec+30,	yyvstop+493},
{329,	yysvec+30,	yyvstop+496},
{331,	yysvec+30,	yyvstop+498},
{325,	yysvec+30,	yyvstop+500},
{334,	0,		0},	
{337,	yysvec+30,	yyvstop+502},
{0,	yysvec+30,	yyvstop+504},
{326,	yysvec+30,	yyvstop+507},
{0,	yysvec+30,	yyvstop+509},
{341,	yysvec+30,	yyvstop+512},
{341,	yysvec+30,	yyvstop+514},
{456,	0,		0},	
{0,	yysvec+30,	yyvstop+516},
{0,	yysvec+30,	yyvstop+519},
{0,	yysvec+30,	yyvstop+522},
{0,	yysvec+30,	yyvstop+525},
{422,	yysvec+247,	0},	
{0,	0,		yyvstop+528},
{0,	0,	0}};
struct yywork *yytop = yycrank+896;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,014 ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
040 ,01  ,'"' ,01  ,01  ,01  ,01  ,047 ,
01  ,01  ,01  ,'+' ,01  ,'+' ,01  ,01  ,
'0' ,'1' ,'1' ,'1' ,'1' ,'1' ,'1' ,'1' ,
'8' ,'8' ,01  ,01  ,01  ,01  ,01  ,'?' ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'F' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'L' ,'G' ,'G' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'G' ,'U' ,'G' ,'G' ,
'X' ,'G' ,'G' ,01  ,047 ,01  ,01  ,01  ,
01  ,'a' ,'a' ,'A' ,'A' ,'E' ,'f' ,'G' ,
'G' ,'G' ,'G' ,'G' ,'L' ,'G' ,'n' ,'G' ,
'G' ,'G' ,'n' ,'G' ,'n' ,'U' ,'v' ,'G' ,
'X' ,'G' ,'G' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* @(#) A.11.01.00 HP C LANGUAGE TOOL (NCFORM) 980815 $      */
#ifdef YYREENTRANT
__thread int yylineno;
#else
int yylineno = 1;
#endif   /* reentrant */

# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
 
#ifdef YYNLS16_WCHAR
#  ifdef YYREENTRANT
__thread unsigned char yytextuc[YYLMAX * sizeof(wchar_t)];
#  else
unsigned char yytextuc[YYLMAX * sizeof(wchar_t)];
#  endif   /* reentrant */

# ifdef YY_PCT_POINT /* for %pointer */
#   ifdef YYREENTRANT
__thread wchar_t yytextarr[YYLMAX];
__thread wchar_t *yytext;
#   else
wchar_t yytextarr[YYLMAX];
wchar_t *yytext;
#   endif            /* reentrant */
# else               /* %array */
#   ifdef YYREENTRANT
__thread wchar_t yytextarr[YYLMAX];
__thread wchar_t yytext[YYLMAX];
#   else
wchar_t yytextarr[YYLMAX];
wchar_t yytext[YYLMAX];
#   endif            /* reentrant */
# endif              /* YY_PCT_POINT */
#else

#  ifdef YYREENTRANT
__thread unsigned char yytextuc;
#  else
unsigned char yytextuc;
#  endif             /* reentrant */
# ifdef YY_PCT_POINT /* for %pointer */
#   ifdef YYREENTRANT
__thread unsigned char yytextarr[YYLMAX];
__thread unsigned char *yytext;
#   else
unsigned char yytextarr[YYLMAX];
unsigned char *yytext;
#   endif            /* reentrant */
# else               /* %array */
#   ifdef YYREENTRANT
__thread unsigned char yytextarr[YYLMAX];
#   else
unsigned char yytextarr[YYLMAX];
#   endif            /* reentrant */

# ifdef YYCHAR_ARRAY
#   ifdef YYREENTRANT
__thread char yytext[YYLMAX];
#   else
char yytext[YYLMAX];
#   endif            /* reentrant */
# else
#   ifdef YYREENTRANT
__thread unsigned char yytext[YYLMAX];
#   else
unsigned char yytext[YYLMAX];
#   endif            /* reentrant */
# endif              /* YYCHAR_ARRAY */
# endif              /* YY_PCT_POINT */
#endif               /* YYNLS16_WCHAR */


#ifdef YYREENTRANT
__thread struct yysvf *yylstate[YYLMAX], **yylsp, **yyolsp;
__thread unsigned char yysbuf[YYLMAX];

__thread unsigned char *yysptr;  /*  = yysbuf; */
__thread int *yyfnd;
__thread extern struct yysvf *yyestate;
#else
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];

unsigned char *yysptr = yysbuf; 
int *yyfnd;
extern struct yysvf *yyestate;
#endif

#ifdef YYREENTRANT
__thread int yyprevious;  /* YYNEWLINE; */
#else
int yyprevious = YYNEWLINE; 
#endif



#ifdef YYREENTRANT
/*
 * initialize tls data.  These were global data and were init 
 * when declared.  Lex will always generate this function 
 * but invoke it only once.  
 */
yyinit_tls()
{
  yylineno = 1;
  yysptr = yysbuf;
  yyprevious = YYNEWLINE; 

  if (!yyin) yyin = stdin;
  if (!yyout) yyout = stdout; 
}
#endif

yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
/*	char *yylastch;
 * ***** nls8 ***** */
	unsigned char *yylastch, sec, third, fourth;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc;
#else
# ifdef YYCHAR_ARRAY
		yylastch = (unsigned char *)yytext;
# else
		yylastch = yytext;
# endif
#endif
	else {
		yymorfg=0;
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc+yylenguc;
#else
# ifdef YYCHAR_ARRAY
		yylastch = (unsigned char *)yytext+yyleng;
# else
		yylastch = yytext+yyleng;
# endif
#endif
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = &yycrank[yystate->yystoff];
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == 0)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;

			if ((long)yyt > (long)yycrank){

				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM

			else if((long)yyt < (long)yycrank) {  /* r < yycrank */

				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt = &yycrank[yystate->yystoff]) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
#ifdef YYNLS16_WCHAR
				yylenguc = yylastch-yytextuc+1;
				yytextuc[yylenguc] = 0;
#else
# ifdef YYCHAR_ARRAY
				yyleng = yylastch-(unsigned char*)yytext+1;
# else
				yyleng = yylastch-yytext+1;
# endif
				yytext[yyleng] = 0;
#endif
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
#ifdef YYNLS16_WCHAR
					sprint(yytextuc);
#else
					sprint(yytext);
#endif
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
#ifdef YYNLS16_WCHAR
		if (yytextuc[0] == 0  /* && feof(yyin) */)
#else
		if (yytext[0] == 0  /* && feof(yyin) */)
#endif
			{
			yysptr=yysbuf;
			return(0);
			}
#ifdef YYNLS16_WCHAR
		yyprevious = yytextuc[0] = input();
#else
		yyprevious = yytext[0] = input();
#endif
		if (yyprevious>0) {
			output(yyprevious);
#ifdef YYNLS16
                        if (yynls16) {
			int noBytes;
                        sec = input();
                        third = input();
                        fourth = input();
#ifdef YYNLS16_WCHAR
                        noBytes = MultiByte(yytextuc[0],sec,third,fourth);
#else 
                        noBytes = MultiByte(yytext[0],sec,third,fourth);
#endif          
     					switch(noBytes) {
     					case 2:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
#else
 						output(yyprevious=yytext[0]=sec);
#endif
                                                 unput(fourth);
                                                 unput(third);
                                                 break;
     					case 3:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
 						output(yyprevious=yytextuc[0]=third);
#else
 						output(yyprevious=yytext[0]=sec);
 						output(yyprevious=yytext[0]=third);
#endif
                                                 unput(fourth);
                                                 break; 
                                         case 4:
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
 						output(yyprevious=yytextuc[0]=third);
 						output(yyprevious=yytextuc[0]=fourth);
#else
 						output(yyprevious=yytext[0]=sec);
 						output(yyprevious=yytext[0]=third);
 						output(yyprevious=yytext[0]=fourth);
#endif
                                                 break;                                                                                            
					default:
					        unput(fourth);
					        unput(third);
						unput(sec);
						break;
						}
					}
#endif
                }
#ifdef YYNLS16_WCHAR
		yylastch=yytextuc;
#else
# ifdef YYCHAR_ARRAY
		yylastch=(unsigned char*)yytext;
# else
		yylastch=yytext;
# endif
#endif
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}

# ifdef __cplusplus
yyback(int *p, int m)
# else
yyback(p, m)
	int *p;
# endif
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	
	}

#if (defined(__cplusplus) || defined(__STDC__))
void yyoutput(int c)
#else
yyoutput(c)
  int c;
# endif
{
	output(c);
}

#if (defined(__cplusplus) || defined(__STDC__))
void yyunput(int c)
#else
yyunput(c)
   int c;
#endif
{
	unput(c);
}
