/*$Header: operands.c,v 4.0 94/02/01 20:22:03 tedd Exp $*/

#include "sp-code.h"
#include "common.h"

/*       change_operand_tree

         called by : lex,

         this procedure either updated the current information in the
         binary tree that matches string or adds another node for this
         operand.
 */

void change_operand_tree( char *string )
{
  struct module_info *temp_mod = CURRENT_MODULE;
  struct tree *temp_tree;

/* PWO */ 
if (DEBUG) printf("change_operands_tree: %s\n",string);

  while( temp_mod->code_block != GLOBAL && temp_mod != GLOBAL )
    temp_mod = temp_mod ->code_block;
  
  if( temp_mod->operands )
  {
    int added = 0, diff = 1;
    temp_tree = temp_mod->operands;
    for( diff = strcmp( string, temp_tree->information->id_name);
        diff && !added;
        diff = strcmp(string, temp_tree->information->id_name))
    {
      if(diff<0)
      {
        if(temp_tree->left_node)
          temp_tree = temp_tree->left_node;
        else
        {
          temp_tree->left_node=malloc_tree();
          temp_tree = temp_tree->left_node;
          temp_tree->information->id_name=
            copy_string(string);
          added = 1;
        }
      }
      else if( diff > 0 )
      {
        if(temp_tree->right_node)
          temp_tree = temp_tree->right_node;
        else
        {
          temp_tree->right_node=malloc_tree();
          temp_tree = temp_tree->right_node;
          temp_tree->information->id_name=
            copy_string(string);
          added = 1;
        }
      }
    }
  }
  else
  {
    temp_tree = temp_mod->operands = malloc_tree();
    temp_tree->information->id_name=copy_string(string);
  }
  temp_tree->information->num_of_times_seen ++;
}

/*     traverse_operand_tree
                          
       called by : end_code_block.
                          
       This procedure traverses the operand tree to find the needed
       information about the current procedure.  the information is put
       in the current module.
 */

void traverse_operand_tree( struct tree *node )
{
  if( !node )	
    return;
  if( node->left_node )
    traverse_operand_tree( node->left_node );
  if( node->right_node )
    traverse_operand_tree( node->right_node );
  
  if(DEBUG) printf("operand -- %s -- seen %d times\n", 
	    node->information->id_name, node->information->num_of_times_seen );
    
  CURRENT_MODULE->operands_unique++;
  CURRENT_MODULE->operands_total += node->information->num_of_times_seen;
  free(node);
}





